---
- hosts: localhost
  gather_facts: no
  connection: local
  tasks:
    - name: Import Variables via Tasks
      include_tasks:
        file: ../../import_vars.yml

    - name: Override Imported Variables
      set_fact:
        host_save_dir: "/tmp/molecule-{{ molecule_role_name }}"
        host_xand_dir: "/tmp/molecule-{{ molecule_role_name }}/{{ molecule_xand_dir }}"

    - name: Create tmp directory on host for molecule use
      file:
        path: "{{ host_xand_dir }}/ansible/passwd.d"
        owner: "{{ lookup('env', 'USER') }}"
        state: directory

    - name: Login to Docker Registry
      docker_login:
        registry: "{{ docker_registry_url }}"
        username: "{{ docker_registry_username }}"
        password: "{{ docker_registry_password }}"

    - name: Create toolchain container
      docker_container:
        name: molecule-toolchain
        image: "{{ docker_registry_base }}/xand-devops-toolchain:{{ toolchain_version }}"
        command: tail -f /dev/null

    - name: Add container to inventory
      add_host:
        name: molecule-toolchain
        ansible_host: molecule-toolchain
        ansible_connection: docker
        ansible_python_interpreter: /usr/bin/python3
        ansible_pipelining: yes
        host_save_dir: "/tmp/molecule-{{ molecule_role_name }}"
        host_xand_dir: "{{ host_save_dir }}/{{ molecule_xand_dir }}/"
        host_member_api_dir: "{{ host_save_dir }}/{{ molecule_member_api_dir }}/"
        groups:
          - molecule_container

- hosts: molecule_container
  tasks:
    - name: Import Variables via Tasks
      include_tasks:
        file: ../../import_vars.yml

    - name: Create save dir
      file:
        path: "{{ remote_save_dir }}/{{ molecule_xand_dir }}/ansible/passwd.d"
        state: directory

- hosts: molecule_container
  gather_facts: no
  roles:
    - role: cluster-creation
    - role: cluster-configuration
